<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑分销商提现明细表' : '添加分销商提现明细表'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="分销商用户ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入分销商用户ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="提现金额" name="money">
        <a-input
          allow-clear
          placeholder="请输入提现金额"
          v-model:value="form.money"
        />
      </a-form-item>
      <a-form-item label="打款方式 (10微信 20支付宝 30银行卡)" name="payType">
        <a-input
          allow-clear
          placeholder="请输入打款方式 (10微信 20支付宝 30银行卡)"
          v-model:value="form.payType"
        />
      </a-form-item>
      <a-form-item label="支付宝姓名" name="alipayName">
        <a-input
          allow-clear
          placeholder="请输入支付宝姓名"
          v-model:value="form.alipayName"
        />
      </a-form-item>
      <a-form-item label="支付宝账号" name="alipayAccount">
        <a-input
          allow-clear
          placeholder="请输入支付宝账号"
          v-model:value="form.alipayAccount"
        />
      </a-form-item>
      <a-form-item label="开户行名称" name="bankName">
        <a-input
          allow-clear
          placeholder="请输入开户行名称"
          v-model:value="form.bankName"
        />
      </a-form-item>
      <a-form-item label="银行开户名" name="bankAccount">
        <a-input
          allow-clear
          placeholder="请输入银行开户名"
          v-model:value="form.bankAccount"
        />
      </a-form-item>
      <a-form-item label="银行卡号" name="bankCard">
        <a-input
          allow-clear
          placeholder="请输入银行卡号"
          v-model:value="form.bankCard"
        />
      </a-form-item>
      <a-form-item label="申请状态 (10待审核 20审核通过 30驳回 40已打款)" name="applyStatus">
        <a-input
          allow-clear
          placeholder="请输入申请状态 (10待审核 20审核通过 30驳回 40已打款)"
          v-model:value="form.applyStatus"
        />
      </a-form-item>
      <a-form-item label="审核时间" name="auditTime">
        <a-input
          allow-clear
          placeholder="请输入审核时间"
          v-model:value="form.auditTime"
        />
      </a-form-item>
      <a-form-item label="驳回原因" name="rejectReason">
        <a-input
          allow-clear
          placeholder="请输入驳回原因"
          v-model:value="form.rejectReason"
        />
      </a-form-item>
      <a-form-item label="来源客户端(APP、H5、小程序等)" name="platform">
        <a-input
          allow-clear
          placeholder="请输入来源客户端(APP、H5、小程序等)"
          v-model:value="form.platform"
        />
      </a-form-item>
      <a-form-item label="修改时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入修改时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addDealerWithdraw, updateDealerWithdraw } from '@/api/shop/dealerWithdraw';
  import { DealerWithdraw } from '@/api/shop/dealerWithdraw/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: DealerWithdraw | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<DealerWithdraw>({
    id: undefined,
    userId: undefined,
    money: undefined,
    payType: undefined,
    alipayName: undefined,
    alipayAccount: undefined,
    bankName: undefined,
    bankAccount: undefined,
    bankCard: undefined,
    applyStatus: undefined,
    auditTime: undefined,
    rejectReason: undefined,
    platform: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    dealerWithdrawId: undefined,
    dealerWithdrawName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    dealerWithdrawName: [
      {
        required: true,
        type: 'string',
        message: '请填写分销商提现明细表名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateDealerWithdraw : addDealerWithdraw;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
